﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ServiceModel;
using System.IdentityModel.Claims;

namespace Server.Security
{
    public class CustomServiceAuthorizationManager : ServiceAuthorizationManager
    {
        protected override bool CheckAccessCore(OperationContext Context)
        {
            string action = Context.RequestContext.RequestMessage.Headers.Action;
            foreach (ClaimSet cs in Context.ServiceSecurityContext.AuthorizationContext.ClaimSets)
            {
                if (cs.Issuer == ClaimSet.System)
                {
                    foreach (Claim c in cs.FindClaims("net.tcp://espier.cc/HandRegister/", Rights.PossessProperty))
                    {
                        Console.WriteLine("正在比较权限：" + action + "和" + c.Resource.ToString());
                        if (action == c.Resource.ToString())
                            return true;
                    }
                }
            }
            return false;
        }

    }
}